schematic_tool_events:
    type: world
    debug: true
    events:
        on player left clicks block with:schematic_tool:
        - if <context.location.exists>:
            - flag player first_corner:<context.location>
            - narrate "corner 1 set"
            - determine cancelled

        on player right clicks block with:schematic_tool:
        - if <context.location.exists>:
            - flag player second_corner:<context.location>
            - narrate "corner 2 set"
            - determine cancelled

schematic_tool:
    type: item
    display name: dungeon schematic tool
    material: arrow

dungeon_schematic_command:
    type: command
    name: schematicdungeon
    description: create a dungeon schematic
    usage: /schematicdungeon tool/create
    aliases:
    - sd
    permission: dungeonschematic.command
    tab completions:
        1: create|tool
    script:
    - choose <context.args.get[1].if_null[no_args]>:
        - case create:
            - if <context.args.get[2].exists>:
                - if <player.has_flag[first_corner]> && <player.has_flag[second_corner]>:
                    - if <server.has_file[schematics/<context.args.get[2]>.schem]> && <context.args.get[3].if_null[no_flags]> != -f:
                        - narrate "a schematic with this name already exists<&nl>use <&dq>/schematic create (name) -f<&dq> to overwrite"
                        - stop
                    - define schematic_cuboid <player.flag[first_corner].to_cuboid[<player.flag[second_corner]>]>
                    - if <[schematic_cuboid].size.x> != 21 || <[schematic_cuboid].size.z> != 21:
                        - narrate "invalid schematic dimensions, 21 x 21 only, see readme for details"
                        - stop
                    - if <schematic[<context.args.get[2]>].exists>:
                        - schematic unload name:<context.args.get[2]>
                    - schematic create name:<context.args.get[2]> <[schematic_cuboid]> <[schematic_cuboid].min> flags
                    - schematic save name:<context.args.get[2]>
                    - narrate "schematic created"
                    - stop
                - else:
                    - narrate "select 2 positions to create a schematic"
            - else:
                - narrate "invalid syntax use <&dq>/schematic create (name)<&dq>"
        - case tool:
            - give schematic_tool
            - stop