determine_loot:
    type: task
    debug: false
    definitions: location
    script:
    - if <[location].inventory.exists>:
        - define loottables <[location].inventory.list_contents.filter_tag[<[filter_value].has_flag[loottable]>].parse_tag[<[parse_value].flag[loottable]>]>
        - take flagged:loottable from:<[location].inventory> quantity:1000
        - foreach <[loottables]>:
            - if !<script[<[value]>].exists>:
                - log error "error invalid loottable name <[value]> at <[location]>"
                - foreach next
            - define loottable <script[<[value]>].data_key[loot]>
            - define max_weight 0
            - foreach <[loottable].keys>:
                - if <[loottable].deep_get[<[value]>.weight].is_integer.if_null[false]>:
                    - define max_weight:+:<[loottable].deep_get[<[value]>.weight]>
                - else:
                    - define max_weight:++
            - define random_roll <util.random.decimal[0].to[<[max_weight]>]>
            - define current_weight 0
            - foreach <[loottable].keys>:
                - if <[loottable].deep_get[<[value]>.weight].if_null[1].add[<[current_weight]>]> >= <[random_roll]>:
                    - define slot_index <util.random.int[1].to[<[location].inventory.empty_slots>]>
                    - define target_slot <[location].inventory.list_contents.pad_right[27].with[<item[air]>].find_all[<item[air]>].get[<[slot_index]>]>
                    - if <[loottable].deep_get[<[value]>.quantity].if_null[1].as_list.size> > 1:
                        - define min_max <[loottable].deep_get[<[value]>.quantity]>
                        - define quantity <util.random.int[<[min_max].as_list.get[1]>].to[<[min_max].as_list.get[2]>]>
                    - else:
                        - define quantity <[loottable].deep_get[<[value]>.quantity].if_null[1]>
                    - inventory set origin:<item[<[value].before[#]>].with[quantity=<[quantity]>]> destination:<[location].inventory> slot:<[target_slot]>
                    - foreach stop
                - else:
                    - define current_weight:+:<[loottable].deep_get[<[value]>.weight].if_null[1]>
    - else:
        - debug error "location does not contain an inventory"
randomloot:
    type: command
    name: randomloot
    description: get a item that generates random loot in a dungeon or when the determine_loot task is called on that location
    usage: /randomloot (table_name)
    debug: false
    aliases:
    - rl
    permission: randomloot.item
    permission message: You dont have permission to use this command
    tab completions:
        1: name
        2: -o
    script:
    - if <context.args.get[1].exists>:
        - if <script[<context.args.get[1]>].exists> || <context.args.get[2].if_null[null]> == -o:
            - define slot <player.inventory.first_empty>
            - give randomloot_placeholder slot:<[slot]>
            - inventory adjust d:<player.inventory> slot:<[slot]> lore:loottable:<&sp><context.args.get[1]>
            - inventory flag d:<player.inventory> slot:<[slot]> loottable:<context.args.get[1]>
        - else:
            - narrate "this loottable doesnt exists, use /randomloot (name) -o to override this"
    - else:
        - narrate "<dark_red>specify a loottable to use"
randomloot_placeholder:
    type: item
    material: stick
    display name: randomloot placeholder