randommobs_events:
    type: world
    debug: true
    events:
        after player places randommobs_placeholder:
        - flag <context.location> randommobs:<context.item_in_hand.flag[randommobs]>
        on player enters area_flagged:random_spawners:
        - foreach <context.area.flag[random_spawners]>:
            - if <[value].material.name> != air:
                - run determine_entity def:<[value]>
        - flag <context.area> random_spawners:!
        - note remove as:<context.area.note_name>

determine_entity:
    type: task
    debug: false
    definitions: location
    script:
    - if <[location].has_flag[randommobs]>:
        - define temp <[location]>
        - define options <[location].flag[randommobs]>
        - choose <[options].get[type]>:
            - case mythicmobs:
                - if <[options].get[random]>:
                    - if !<script[<[options].get[name]>].exists>:
                        - debug error "error invalid mob table name <[options].get[name]>"
                        - stop
                    - define mobtable <script[<[options].get[name]>].data_key[mobs]>

                    - foreach <[mobtable].keys>:
                        - if <[mobtable].deep_get[<[value]>.weight].is_integer.if_null[false]>:
                            - define max_weight:+:<[mobtable].deep_get[<[value]>.weight]>
                        - else:
                            - define max_weight:++
                    - define random_roll <util.random.decimal[0].to[<[max_weight]>]>
                    - define current_weight 0
                    - foreach <[mobtable].keys>:
                        - if <[mobtable].deep_get[<[value]>.weight].if_null[1].add[<[current_weight]>]> >= <[random_roll]>:
                            - if <[mobtable].deep_get[<[value]>.quantity].if_null[1].as_list.size> > 1:
                                - define min_max <[mobtable].deep_get[<[value]>.quantity]>
                                - define quantity <util.random.int[<[min_max].as_list.get[1]>].to[<[min_max].as_list.get[2]>]>
                            - else:
                                - define quantity <[mobtable].deep_get[<[value]>.quantity].if_null[1]>
                            - modifyblock <[location]> air
                            - define entity <[value]>
                            - repeat <[quantity]>:
                                - mythicspawn <[entity].before[#]> <[location].center>
                            - foreach stop
                        - else:
                            - define current_weight:+:<[mobtable].deep_get[<[value]>.weight].if_null[1]>
                - else:
                    - define args "1 <[location].world>,<[location].xyz>"
                    - mythicspawn <[options].name> <[location].center>


            - case denizen:
                - if !<script[<[options].get[name]>].exists>:
                    - debug error "error invalid script name <[options].get[name]>"
                    - stop
                - if <[options].get[random]>:
                    - define mobtable <script[<[options].get[name]>].data_key[mobs]>
                    - foreach <[mobtable].keys>:
                        - if <[mobtable].deep_get[<[value]>.weight].is_integer.if_null[false]>:
                            - define max_weight:+:<[mobtable].deep_get[<[value]>.weight]>
                        - else:
                            - define max_weight:++
                    - define random_roll <util.random.decimal[0].to[<[max_weight]>]>
                    - define current_weight 0
                    - foreach <[mobtable].keys>:
                        - if <[mobtable].deep_get[<[value]>.weight].if_null[1].add[<[current_weight]>]> >= <[random_roll]>:
                            - if <[mobtable].deep_get[<[value]>.quantity].if_null[1].as_list.size> > 1:
                                - define min_max <[mobtable].deep_get[<[value]>.quantity].if_null[1]>
                                - define quantity <util.random.int[<[min_max].as_list.get[1]>].to[<[min_max].as_list.get[2]>]>
                            - else:
                                - define quantity <[mobtable].deep_get[<[value]>.quantity].if_null[1]>
                            - if !<script[<[value].before[#]>].exists>:
                                - debug error "error invalid script name <[options].get[name]>"
                                - stop
                            - modifyblock <[location]> air
                            - define entity <[value]>
                            - repeat <[quantity]>:
                                - spawn <[entity].before[#]> <[location].center> persistent
                            - foreach stop
                        - else:
                            - define current_weight:+:<[mobtable].deep_get[<[value]>.weight].if_null[1]>
                - else:
                    # TODO add quantity to single entity
                    - modifyblock <[location]> air
                    - spawn <[options].get[name]> <[location].center> persistent

randommobs:
    type: command
    name: randommobs
    description: get a item that generates random mobs in a dungeon or when the determine_entity task is called on that location
    usage: /randommobs denizen|mythic single|random (name)
    debug: false
    aliases:
    - rm
    permission: randommobs.item
    permission message: You dont have permission to use this command
    tab completions:
        1: mythic|denizen
        2: single|random
        3: name
    script:
    - if <context.args.size> < 3:
        - narrate "error, not enough arguments specified"
        - stop
    - if !<list[denizen|mythic].contains_any[<context.args.get[1]>]>:
        - narrate "error, only denizen and mythic are valid types"
        - stop
    - choose <context.args.get[2]>:
        - case single:
            - define random false
        - case random:
            - define random true
        - default:
            - narrate "error, only single and random are valid types"
            - stop
    - define slot <player.inventory.first_empty>
    - give randommobs_placeholder slot:<[slot]>
    - inventory adjust d:<player.inventory> slot:<[slot]> lore:type:<&sp><context.args.get[1]><&nl>random<&sp>entity:<&sp><[random]><&nl>name:<&sp><context.args.get[3]>
    - inventory flag d:<player.inventory> slot:<[slot]> randommobs.type:<context.args.get[1]>
    - inventory flag d:<player.inventory> slot:<[slot]> randommobs.random:<[random]>
    - inventory flag d:<player.inventory> slot:<[slot]> randommobs.name:<context.args.get[3]>

randommobs_placeholder:
    type: item
    material: spawner
    display name: randommobs placeholder