# instructions
# use - ~run sign_prompt def:<[message]> save:sign_prompt_output
# to run the task
# afterwards the signs contents can be read with <entry[sign_prompt_output].created_queue.determination.get[1]>
# this returns a list of the signs contents or timeout if nothing was entered within 1 minute
sign_prompt_events:
    type: world
    events:
        on player changes sign flagged:sign_prompt:
        - if <player.has_flag[open_inventory]>:
            - inventory open d:<player.flag[open_inventory]>
            - if <inventory[sign_prompt_temp_<player.uuid>].exists>:
                - inventory set d:<player.open_inventory> o:sign_prompt_temp_<player.uuid>
                - note remove as:sign_prompt_temp_<player.uuid>
            - flag player open_inventory:!
        - flag <player> sign_prompt_output:<context.new>
        - modifyblock <player.flag[sign_prompt]> bedrock
        - modifyblock <player.flag[sign_prompt]> bedrock
        - modifyblock <player.flag[sign_prompt].above> <player.flag[sign_prompt].above.flag[sign_prompt_old_block]>
        - flag <player.flag[sign_prompt].above> sign_prompt_old_block:!
        - flag server sign_prompt:<-:<player.flag[sign_prompt]>
        - flag <player> sign_prompt:!

        on player quits flagged:sign_prompt:
        - modifyblock <player.flag[sign_prompt]> bedrock
        - modifyblock <player.flag[sign_prompt].above> <player.flag[sign_prompt].above.flag[sign_prompt_old_block]>
        - flag <player.flag[sign_prompt].above> sign_prompt_old_block:!
        - if <player.has_flag[open_inventory]>:
            - if <inventory[sign_prompt_temp_<player.uuid>].exists>:
                - note remove as:sign_prompt_temp_<player.uuid>
            - flag player open_inventory:!
        - flag <player> sign_prompt_output:timeout
        - flag server sign_prompt:<-:<player.flag[sign_prompt]>
        - flag <player> sign_prompt:!

        on server start:
        - if <server.has_flag[sign_prompt]>:
            - foreach <server.flag[sign_prompt]>:
                - modifyblock <[value]> bedrock
                - modifyblock <[value].above> <[value].above.flag[sign_prompt_old_block]>
                - flag <[value].above> sign_prompt_old_block:!
                - flag server sign_prompt:<-:<[value]>

        on player joins flagged:sign_prompt:
        - flag player sign_prompt:!
        - if <player.has_flag[open_inventory]>:
            - if <inventory[sign_prompt_temp_<player.uuid>].exists>:
                - note remove as:sign_prompt_temp_<player.uuid>
            - flag player open_inventory:!
        - flag server sign_prompt:<-:<player.flag[sign_prompt]>
        - flag <player> sign_prompt:!

sign_prompt:
    type: task
    definitions: message
    script:
    - if <player.has_flag[sign_prompt]>:
        - debug error "Invalid sign prompt message, must be a list"
        - determine error
    - if !<[message].size.exists>:
        - debug error "Invalid sign prompt message, must be a list"
        - determine error
    - if <[message].size> > 4:
        - debug error "Invalid sign prompt message, list must have 1-4 entries"
        - determine error
    - define sign_location <player.location.with_y[0]>
    - while <list[air|bedrock].contains[<[sign_location].material.name>].not>:
        - if <[loop_index]> == 16:
            - define sign_location <[sign_location].add[0,0,1]>
        - else:
            - define sign_location <[sign_location].add[1,0,0]>

    - flag player sign_prompt:<[sign_location]>
    - flag server sign_prompt:->:<[sign_location]>
    - if <player.open_inventory.id_type.if_null[player]> != player:
        - if <player.open_inventory.id_type> == script:
            - note <player.open_inventory> as:sign_prompt_temp_<player.uuid>
            - flag player open_inventory:<player.open_inventory.id_holder.name>
        - else:
            - flag player open_inventory:<player.open_inventory>
    - modifyblock <[sign_location]> oak_wall_sign
    - flag <[sign_location].above> sign_prompt_old_block:<[sign_location].above.material>
    - modifyblock <[sign_location].above> bedrock
    - adjust <[sign_location]> sign_contents:<[message]>
    - wait 2t
    - adjust <player> edit_sign:<[sign_location]>
    - wait 1s
    - waituntil rate:10t max:1m <player.has_flag[sign_prompt_output]>
    - if <player.has_flag[sign_prompt_output]>:
        - define output <player.flag[sign_prompt_output]>
        - flag player sign_prompt_output:!
    - else:
        - if !<player.is_online>:
            - determine timeout
        - if <player.has_flag[open_inventory]>:
            - inventory open d:<player.flag[open_inventory]>
            - if <inventory[sign_prompt_temp_<player.uuid>].exists>:
                - inventory set d:<player.open_inventory> o:sign_prompt_temp_<player.uuid>
                - note remove as:sign_prompt_temp_<player.uuid>
            - flag player open_inventory:!
            - determine timeout
        - else:
            - inventory close
            - determine timeout

        - define output timeout
    - determine <[output]>